# Class CompoundDocument

java.lang.Object
javajs.util.BC
javajs.util.BinaryDocument
javajs.util.CompoundDocument

All Implemented Interfaces:
  `GenericBinaryDocument, GenericBinaryDocumentReader`

public class CompoundDocument extends BinaryDocument

## Field Summary

Fields
Modifier and Type
Field
Description
`protected GenericZipTools`
`jzt`

### Fields inherited from class BinaryDocument

`bis, isBigEndian, isRandom, nBytes, out, stream`

## Constructor Summary

Constructors
Constructor
Description
`CompoundDocument()`

## Method Summary

Modifier and Type
Method
Description
`SB`
`getAllData()`
`SB`
`getAllDataFiles(String binaryFileList, String firstFile)`
`void`
`getAllDataMapped(String prefix, String binaryFileList, Map<String,String> fileData)`
reads a compound document directory and saves all data in a Hashtable so that the files may be organized later in a different order.
`Lst<javajs.util.CompoundDocDirEntry>`
`getDirectory()`
`String`
`getDirectoryListing(String separator)`
`SB`
`getFileAsString(String entryName)`
`void`
`setDocStream(GenericZipTools jzt, BufferedInputStream bis)`

### Methods inherited from class BinaryDocument

`close, getInputStream, getPosition, readByte, readByteArray, readBytes, readDouble, readFloat, readInt, readIntLE, readLong, readShort, readString, readUInt8, readUnsignedShort, seek, setBigEndian, setOutputChannel, setRandom, setStream, setStreamData, swapBytesI, swapBytesS`

### Methods inherited from class BC

`bytesToDoubleToFloat, bytesToFloat, bytesToInt, bytesToShort, intToFloat, intToSignedInt`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### jzt

protected GenericZipTools jzt

## Constructor Details

### CompoundDocument

public CompoundDocument()

## Method Details

### setDocStream

public void setDocStream(GenericZipTools jzt, BufferedInputStream bis)

### getDirectory

public Lst<javajs.util.CompoundDocDirEntry> getDirectory()

### getDirectoryListing

public String getDirectoryListing(String separator)

### getAllData

public SB getAllData()

### getAllDataMapped

public void getAllDataMapped(String prefix, String binaryFileList, Map<String,String> fileData)
reads a compound document directory and saves all data in a Hashtable so that the files may be organized later in a different order. Also adds a #Directory_Listing entry. Files are bracketed by BEGIN Directory Entry and END Directory Entry lines, similar to ZipUtil.getAllData.

Specified by:
  `getAllDataMapped` in interface `GenericBinaryDocument`
Overrides:
  `getAllDataMapped` in class `BinaryDocument`
Parameters:
  `prefix` -
  `binaryFileList` - |-separated list of files that should be saved as xx xx xx hex byte strings. The directory listing is appended with ":asBinaryString"
  `fileData` -

### getAllDataFiles

public SB getAllDataFiles(String binaryFileList, String firstFile)

Specified by:
  `getAllDataFiles` in interface `GenericBinaryDocument`
Overrides:
  `getAllDataFiles` in class `BinaryDocument`

### getFileAsString

public SB getFileAsString(String entryName)